org.apache.xpath.domapi

## Class XPathEvaluatorImpl

- java.lang.Object
- - org.apache.xpath.domapi.XPathEvaluatorImpl

All Implemented Interfaces:
  XPathEvaluator

    public final class XPathEvaluatorImpl
    extends java.lang.Object
    implements XPathEvaluator

The class provides an implementation of XPathEvaluator according to the DOM L3 XPath Specification, Working Group Note 26 February 2004.

See also the Document Object Model (DOM) Level 3 XPath Specification.

The evaluation of XPath expressions is provided by `XPathEvaluator`, which will provide evaluation of XPath 1.0 expressions with no specialized extension functions or variables. It is expected that the `XPathEvaluator` interface will be implemented on the same object which implements the `Document` interface in an implementation which supports the XPath DOM module. `XPathEvaluator` implementations may be available from other sources that may provide support for special extension functions or variables which are not defined in this specification.

See Also:
  `XPathEvaluator`
Usage:
  **For internal use only**

### Constructor Summary

Constructors
Constructor and Description
`XPathEvaluatorImpl()` Constructor in the case that the XPath expression can be evaluated without needing an XML document at all.
`XPathEvaluatorImpl(Document doc)` Constructor for XPathEvaluatorImpl.

### Method Summary

Methods
`XPathExpression` `createExpression(java.lang.String expression, XPathNSResolver resolver)` Creates a parsed XPath expression with resolved namespaces.
`XPathNSResolver` `createNSResolver(Node nodeResolver)` Adapts any DOM node to resolve namespaces so that an XPath expression can be easily evaluated relative to the context of the node where it appeared within the document.
`java.lang.Object` `evaluate(java.lang.String expression, Node contextNode, XPathNSResolver resolver, short type, java.lang.Object result)` Evaluates an XPath expression string and returns a result of the specified type if possible.

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### XPathEvaluatorImpl

    public XPathEvaluatorImpl(Document doc)

Constructor for XPathEvaluatorImpl.

Parameters:
  `doc` - The document to be searched, to parallel the case where'' the XPathEvaluator is obtained by casting the document.

#### XPathEvaluatorImpl

    public XPathEvaluatorImpl()

Constructor in the case that the XPath expression can be evaluated without needing an XML document at all.

### Method Detail

#### createExpression

    public XPathExpression createExpression(java.lang.String expression,
                                   XPathNSResolver resolver)
                                     throws XPathException,
                                            DOMException

Creates a parsed XPath expression with resolved namespaces. This is useful when an expression will be reused in an application since it makes it possible to compile the expression string into a more efficient internal form and preresolve all namespace prefixes which occur within the expression.

Specified by:
  `createExpression` in interface `XPathEvaluator`
Parameters:
  `expression` - The XPath expression string to be parsed.
  `resolver` - The `resolver` permits translation of prefixes within the XPath expression into appropriate namespace URIs . If this is specified as `null`, any namespace prefix within the expression will result in `DOMException` being thrown with the code `NAMESPACE_ERR`.
Returns:
  The compiled form of the XPath expression.
Throws:
  `XPathException` - INVALID_EXPRESSION_ERR: Raised if the expression is not legal according to the rules of the `XPathEvaluator`i
  `DOMException` - NAMESPACE_ERR: Raised if the expression contains namespace prefixes which cannot be resolved by the specified `XPathNSResolver`.
See Also:
  `XPathEvaluator.createExpression(String, XPathNSResolver)`

#### createNSResolver

    public XPathNSResolver createNSResolver(Node nodeResolver)

Adapts any DOM node to resolve namespaces so that an XPath expression can be easily evaluated relative to the context of the node where it appeared within the document. This adapter works like the DOM Level 3 method `lookupNamespaceURI` on nodes in resolving the namespaceURI from a given prefix using the current information available in the node's hierarchy at the time lookupNamespaceURI is called, also correctly resolving the implicit xml prefix.

Specified by:
  `createNSResolver` in interface `XPathEvaluator`
Parameters:
  `nodeResolver` - The node to be used as a context for namespace resolution.
Returns:
  `XPathNSResolver` which resolves namespaces with respect to the definitions in scope for a specified node.
See Also:
  `XPathEvaluator.createNSResolver(Node)`

#### evaluate

    public java.lang.Object evaluate(java.lang.String expression,
                            Node contextNode,
                            XPathNSResolver resolver,
                            short type,
                            java.lang.Object result)
                              throws XPathException,
                                     DOMException

Evaluates an XPath expression string and returns a result of the specified type if possible.

Specified by:
  `evaluate` in interface `XPathEvaluator`
Parameters:
  `expression` - The XPath expression string to be parsed and evaluated.
  `contextNode` - The `context` is context node for the evaluation of this XPath expression. If the XPathEvaluator was obtained by casting the `Document` then this must be owned by the same document and must be a `Document`, `Element`, `Attribute`, `Text`, `CDATASection`, `Comment`, `ProcessingInstruction`, or `XPathNamespace` node. If the context node is a `Text` or a `CDATASection`, then the context is interpreted as the whole logical text node as seen by XPath, unless the node is empty in which case it may not serve as the XPath context.
  `resolver` - The `resolver` permits translation of prefixes within the XPath expression into appropriate namespace URIs . If this is specified as `null`, any namespace prefix within the expression will result in `DOMException` being thrown with the code `NAMESPACE_ERR`.
  `type` - If a specific `type` is specified, then the result will be coerced to return the specified type relying on XPath type conversions and fail if the desired coercion is not possible. This must be one of the type codes of `XPathResult`.
  `result` - The `result` specifies a specific result object which may be reused and returned by this method. If this is specified as `null`or the implementation does not reuse the specified result, a new result object will be constructed and returned.For XPath 1.0 results, this object will be of type `XPathResult`.
Returns:
  The result of the evaluation of the XPath expression.For XPath 1.0 results, this object will be of type `XPathResult`.
Throws:
  `XPathException` - INVALID_EXPRESSION_ERR: Raised if the expression is not legal according to the rules of the `XPathEvaluator`i
  TYPE_ERR: Raised if the result cannot be converted to return the specified type.
  `DOMException` - NAMESPACE_ERR: Raised if the expression contains namespace prefixes which cannot be resolved by the specified `XPathNSResolver`.
  WRONG_DOCUMENT_ERR: The Node is from a document that is not supported by this XPathEvaluator.
  NOT_SUPPORTED_ERR: The Node is not a type permitted as an XPath context node.
See Also:
  `org.w3c.dom.xpath.XPathEvaluator#evaluate(String, Node, XPathNSResolver, short, XPathResult)`